#include <Wire.h>
#include <hd44780.h>
#include <hd44780ioClass/hd44780_I2Cexp.h>
const int i2cAddress = 0x27;                       // I2C address of the LCD1602
const int numRows = 2;                             // number of rows in LCD1602
const int numCols = 16;                            // number of columns in the LCD1602
hd44780_I2Cexp lcd(i2cAddress, numRows, numCols);  // create the LCD1602 object
#include <DHT.h>
DHT dht25(25, 11);
void setup() {
  Wire.begin();
  lcd.begin(numCols, numRows);  // initialize LCD1602
  lcd.backlight();              // turn on the backlight
  delay(500);
  lcd.clear();
  dht25.begin();  // initialize LCD screen and temperature/humidity module
}
void loop() {
  lcd.setCursor(1 - 1, 1 - 1);         // set the cursor position to the first row and first column
  lcd.print("T:");                     // display "T:"
  lcd.setCursor(3 - 1, 1 - 1);         // set the cursor position to the third column of the first row
  lcd.print(dht25.readTemperature());  // display the temperature value of the DHT sensor
  lcd.setCursor(9 - 1, 1 - 1);         // set the cursor position to the ninth column of the first row
  lcd.print("H:");                     // display "H:"
  lcd.setCursor(11 - 1, 1 - 1);        // set the cursor position to the eleventh column of the first row
  lcd.print(dht25.readHumidity());     // display the humidity value of the DHT sensor
  delay(200);                          // delay 200 milliseconds
}
