
#include <Arduino.h>
#include <WiFi.h>
#include <ESPmDNS.h>
#include <WiFiClient.h>
#include <ESP32_Servo.h>
String item = "0";
const char* ssid = "ACEBOTT";//Change to your own WIFI name
const char* password = "12345678"; // Change the WIFI password to your own.
WiFiServer server(80);
volatile int wifi_mark=0,wifi_time=0;
volatile int RGB_RED=0,RGB_GREEN=0,RGB_BLUE=0;
//WIFI configuration


Servo servo_17;
const int window_close=60;
const int window_open=123;
//Window Servo Configuration

Servo servo_18;
const int door_close=5;
const int door_open=100;
//Door Servo Configuration

void setup() {
  /***** show IP address in serial monitor ****/
  Serial.begin(115200);
  WiFi.begin(ssid, password);
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  Serial.println("");
  Serial.print("Connected to ");
  Serial.println(ssid);
  Serial.print("IP address: ");
  Serial.println(WiFi.localIP());
  server.begin();
  Serial.println("TCP server started");
  MDNS.addService("http", "tcp", 80);
 //WIFI initialization

  pinMode(14, INPUT);
  pinMode(32, INPUT);
  pinMode(5, OUTPUT);
  // Initialization of human infrared, photosensitive sensors, LED pins
  
  servo_18.attach(18,500,2500);
  servo_18.write(door_close);
  delay(500);
  pinMode(19, OUTPUT);
  //Initialization of gate servo and relay pins, RFID initialization

  pinMode(33, INPUT);
  servo_17.attach(17,500,2500);
  servo_17.write(window_open);
  delay(500);
  //Initialization of raindrop sensor and window servos 
}

void loop() {
  wifi_controll();
}



/*****wifi control program 006*****/
void wifi_controll(){

  WiFiClient client = server.available();
  if (!client) {
      return;
  }
  while(client.connected() && !client.available()){
      delay(1);
  }
  String req = client.readStringUntil('\r');
  int addr_start = req.indexOf(' ');
  int addr_end = req.indexOf(' ', addr_start + 1);
  if (addr_start == -1 || addr_end == -1) {
      Serial.print("Invalid request: ");
      Serial.println(req);
      return;
  }
  req = req.substring(addr_start + 1, addr_end);
  item=req;
  Serial.println(item);
  String s;
  if (req == "/")  //Browser accesses address can read the information sent by the client.println(s);
  {
      IPAddress ip = WiFi.localIP();
      String ipStr = String(ip[0]) + '.' + String(ip[1]) + '.' + String(ip[2]) + '.' + String(ip[3]);
      s = "HTTP/1.1 200 OK\r\nContent-Type: text/html\r\n\r\n<!DOCTYPE HTML>\r\n<html>Hello from ESP32 at ";
      s += ipStr;
      s += "</html>\r\n\r\n";
      Serial.println("Sending 200");
      client.println(s);  //Send the string S, you can read the information when visiting the address of E smart home using a browser.  
  //client.print(s);
  }
  if(req == "/Test") 
  {
    s = "HTTP/1.1 200 0K\r\nContent-Type: text \r\n\r\n ";
    s += "Test_OK";
    s += "r\n\r\n";
    client.println(s);
  }
  if(req == "/door_on") 
  {
    servo_18.write(door_open);
    client.println("turn on the door");
  }
  if(req == "/door_off") 
  {
    servo_18.write(door_close);
    client.println("turn off the door");
  }
  if(req == "/window_on") 
  {
    servo_17.write(window_open);
    client.println("turn on the window");
  }
  if(req == "/window_off") 
  {
    servo_17.write(window_close);
    client.println("turn off the window");
  }
 
  //client.print(s);
  client.stop();
}

/*****wifi control program 006*****/
