#include <MFRC522_I2C.h>    //call the RFID library
#include <ESP32_Servo.h>    //call servo library
MFRC522_I2C mfrc522(0x28,-1);      //configure RFID address
String rfid_str = "";       //define the variable of string type to read the card number
Servo servo_18;             //configure servo pins
const int door_close = 5;   //define the angle of the door servo to close the door, which can be modified according to the actual situation
const int door_open = 100;  //define the angle of the door servo to open the door, it can be modified according to the actual situation
void setup() {
  Serial.begin(115200);            //initialize the serial port, see the card number used to
  Wire.begin();                    //initialize i2c serial port
  mfrc522.PCD_Init();              //initialize RFID module
  servo_18.attach(18, 500, 2500);  //initialize servos
  servo_18.write(door_close);      //let the servo turn to the initial position
  delay(500);                      //wait for the end of the servo rotation
}
void loop() {
  if (!mfrc522.PICC_IsNewCardPresent() || !mfrc522.PICC_ReadCardSerial()) {
    //if no new card present or if not successfully read card serial number
    delay(50);
    return;  //go back to the main program and start over
  }
  rfid_str = "";  //clear the read card number variable first
  for (byte i = 0; i < mfrc522.uid.size; i++) {
    rfid_str = rfid_str + String(mfrc522.uid.uidByte[i], HEX);
  }  // store the card number verbatim in the string variable rfid_str
  Serial.println(rfid_str);
  servo_18.write(door_open);   //open door
  delay(2000);                 //wait two seconds, can be changed
  servo_18.write(door_close);  //close the door
}
