#include <HardwareSerial.h>  //call the library for the hard serial port
volatile int audio;          //variable storing the voice signal of the serial port
volatile int audio_mark = 0, audio_time = 0;
//configuration of the voice module
#include <ESP32_Servo.h>
Servo servo_17;
const int window_close = 60;
const int window_open = 123;
//window servo configuration
Servo servo_18;
const int door_close = 5;
const int door_open = 100;
//door servo configuration
void setup() {
  // put your setup code here, to run once
  Serial2.begin(115200, SERIAL_8N1, 13, 27);  //configure rx to be 13 pins, tx to be 27 pins, and the serial port name of the voice module is Serial2
  audio = 0;                                  //store the data from the voice serial port into the audio variable
  //initialization of the serial port of the voice module
  servo_18.attach(18, 500, 2500);
  servo_18.write(door_close);
  delay(500);
  //initialization of door servos
  servo_17.attach(17, 500, 2500);
  servo_17.write(window_open);
  delay(500);
  //window servo initialization
}
void loop() {
  audio_controll();
}
/***** voice control program 007*****/
void audio_controll() {
  if ((audio_time != 0) && ((millis() - audio_time) > 8000)) {
    Serial.println("auto_mode");
    audio_mark = 0;
    audio_time = 0;
  }
  if (Serial2.available() > 0) {  // whether the voice serial port is receiving data or not
    audio = Serial2.read();       //store the data from the voice serial port into the audio variable
    Serial.println(audio, HEX);   //use the serial port on the computer side to send the value in hexadecimal form to the computer's serial port monitor
    Serial.println("audio_mode");
    if (audio == 0x02) {
      servo_18.write(door_open);
    }
    if (audio == 0x03) {
      servo_18.write(door_close);
    }
    if (audio == 0x04) {
      servo_17.write(window_open);
    }
    if (audio == 0x05) {
      servo_17.write(window_close);
    }
  }
}
/***** voice control program 007*****/