
#include <Arduino.h>
#include <WiFi.h>
#include <ESPmDNS.h>
#include <WiFiClient.h>
String item = "0";
const char* ssid = "ACEBOTT";//change to your own WIFI name
const char* password = "12345678"; // change the WIFI password to your own
WiFiServer server(80);
volatile int wifi_mark=0,wifi_time=0;
volatile int RGB_RED=0,RGB_GREEN=0,RGB_BLUE=0;
//WIFI configuration
void setup() {
  Serial.begin(115200);
  WiFi.begin(ssid, password);
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  Serial.println("");
  Serial.print("Connected to ");
  Serial.println(ssid);
  Serial.print("IP address: ");
  Serial.println(WiFi.localIP());
  server.begin();
  Serial.println("TCP server started");
  MDNS.addService("http", "tcp", 80);
  //WIFI initialization
  pinMode(5, OUTPUT);
  //LED pin initialization
}
void loop() {
  wifi_controll();
}
/*****wifi control program 006*****/
void wifi_controll(){
  WiFiClient client = server.available();
  if (!client) {
      return;
  }
  while(client.connected() && !client.available()){
      delay(1);
  }
  String req = client.readStringUntil('\r');
  int addr_start = req.indexOf(' ');
  int addr_end = req.indexOf(' ', addr_start + 1);
  if (addr_start == -1 || addr_end == -1) {
      Serial.print("Invalid request: ");
      Serial.println(req);
      return;
  }
  req = req.substring(addr_start + 1, addr_end);
  item=req;
  Serial.println(item);
  String s;
  if (req == "/")  //browser accesses address can read the information sent by 'the client.println(s);'
  {
      IPAddress ip = WiFi.localIP();
      String ipStr = String(ip[0]) + '.' + String(ip[1]) + '.' + String(ip[2]) + '.' + String(ip[3]);
      s = "HTTP/1.1 200 OK\r\nContent-Type: text/html\r\n\r\n<!DOCTYPE HTML>\r\n<html>Hello from ESP32 at ";
      s += ipStr;
      s += "</html>\r\n\r\n";
      Serial.println("Sending 200");
      client.println(s);  //send the string S, you can read the information when visiting the address of E smart home using a browser  
  }
  if(req == "/Test") 
  {
    s = "HTTP/1.1 200 0K\r\nContent-Type: text \r\n\r\n ";
    s += "Test_OK";
    s += "\n\r\n";
    client.println(s);
  }
  if(req == "/LED_on") //browser accesses the ip address/led/on
  {
    digitalWrite(5,HIGH);
    client.println("turn on the LED");
  }
  if(req == "/LED_off") 
  {
    digitalWrite(5,LOW);
    client.println("turn off the LED");
  }
  client.stop();
}
/*****wifi control program 006*****/
