
#include <Arduino.h>
#include <WiFi.h>
#include <ESPmDNS.h>
#include <WiFiClient.h>
String item = "0";
const char* ssid = "ACEBOTT";//change to your own WIFI name
const char* password = "12345678"; // change the WIFI password to your own
WiFiServer server(80);
volatile int wifi_mark=0,wifi_time=0;
volatile int RGB_RED=0,RGB_GREEN=0,RGB_BLUE=0;
//WIFI configuration

#include <Adafruit_NeoPixel.h>
Adafruit_NeoPixel rgb_display_16 = Adafruit_NeoPixel(10,16,NEO_GRB + NEO_KHZ800);
volatile int buttun;
//configuration of variables for buttons and RGB's

#include <DHT.h>
DHT dht25(25, 11);
//configuration of temperature and humidity modules

#include <ESP32_Servo.h>
Servo servo_17;
const int window_close=60;
const int window_open=123;
//window servo configurations

Servo servo_18;
const int door_close=5;
const int door_open=100;
//door servo configuration

void setup() {

  Serial.begin(115200);
  WiFi.begin(ssid, password);
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  Serial.println("");
  Serial.print("Connected to ");
  Serial.println(ssid);
  Serial.print("IP address: ");
  Serial.println(WiFi.localIP());
  server.begin();
  Serial.println("TCP server started");
  MDNS.addService("http", "tcp", 80);
 //WIFI initialization


  pinMode(14, INPUT);
  pinMode(32, INPUT);
  pinMode(5, OUTPUT);
  // initialization of human infrared, photosensitive sensors, LED pins
   
  pinMode(26, INPUT);
  pinMode(23, OUTPUT);
  rgb_display_16.begin();
  buttun = 0;
  // initialization of buttons, laser lights, abyssal lights (light strips)
  //mfrc522.PCD_Init();
  servo_18.attach(18,500,2500);
  servo_18.write(door_close);
  delay(500);
  // door servo initialization

  pinMode(33, INPUT);
  servo_17.attach(17,500,2500);
  servo_17.write(window_close);
  delay(500);
 // initialization of Raindrop Sensor and Window Servo
  
}

void loop() {
  // put your main code here, to run repeatedly

wifi_controll();
}

/****** laser program ******/
void rgb_all(int j,int rgb_r,int rgb_g,int rgb_b){
  for (int i = 1; i <= j; i++) {
        rgb_display_16.setPixelColor((i)-1, (((rgb_r & 0xffffff) << 16) | ((rgb_g & 0xffffff) << 8) | rgb_b));
      }
}
//simplifying the abyssal lamp control program using program subfunctions
/******button abyssal lamp and laser program 002******/
/*****wifi control program 006*****/
void wifi_controll(){

  if ((wifi_time!=0)&&((millis()-wifi_time)>8000))
  {
    Serial.println("auto_mode");
    wifi_mark=0;
    wifi_time=0;
  }
  WiFiClient client = server.available();
  if (!client) {
      return;
  }
  while(client.connected() && !client.available()){
      delay(1);
  }
  String req = client.readStringUntil('\r');
  int addr_start = req.indexOf(' ');
  int addr_end = req.indexOf(' ', addr_start + 1);
  if (addr_start == -1 || addr_end == -1) {
      Serial.print("Invalid request: ");
      Serial.println(req);
      return;
  }
  req = req.substring(addr_start + 1, addr_end);
  item=req;
  wifi_mark=1;
  wifi_time=millis();
  Serial.println(item);
  String s;
  if (req == "/")  //browser accesses address can read the information sent by 'the client.println(s);'
  {
      IPAddress ip = WiFi.localIP();
      String ipStr = String(ip[0]) + '.' + String(ip[1]) + '.' + String(ip[2]) + '.' + String(ip[3]);
      s = "HTTP/1.1 200 OK\r\nContent-Type: text/html\r\n\r\n<!DOCTYPE HTML>\r\n<html>Hello from ESP32 at ";
      s += ipStr;
      s += "</html>\r\n\r\n";
      Serial.println("Sending 200");
      client.println(s);  //send the string S, you can read the information when visiting the address of E smart home using a browser  
  
  }

  if(req == "/Test") 
  {
    s = "HTTP/1.1 200 0K\r\nContent-Type: text \r\n\r\n ";
    s += "Test_OK";
    s += "r\n\r\n";
    client.println(s);
  }
  if(req == "/LED_on") //browser accesses the ip address/led/on
  {
    digitalWrite(5,HIGH);
    client.println("turn on the LED");
  }
  if(req == "/LED_off") 
  {
    digitalWrite(5,LOW);
    client.println("turn off the LED");
  }
  if(req == "/laser_on") 
  {
    digitalWrite(23,HIGH);
    client.println("turn on the jiguang");
  }
  if(req == "/laser_off") 
  {
    digitalWrite(23,LOW);
    client.println("turn off the jiguang");
  }
  
  if(req == "/RGB_on") 
  {
    rgb_display_16.setBrightness(100);
    rgb_all(10,0,0,100);
    rgb_display_16.show();
    client.println("turn on the shenyuan");
  }
  if(req == "/RGB_off") 
  {
    rgb_display_16.setBrightness(0);
    rgb_display_16.show();
    client.println("turn off the shenyuan");
  }
  if(hasNumber(req)==1)
  {
    Serial.println("hasNumber(req)==1");
    char result[10];
    extractCharacters(req, result);
    Serial.println(result);
    if(strcmp(result,"RGB_B")==0){
      RGB_BLUE=extractNumbers(req);
      Serial.println("result==RGB_B");
    }
    else if(strcmp(result,"RGB_G")==0){
      RGB_GREEN=extractNumbers(req);
      Serial.println("result==RGB_G");
    }
    else if(strcmp(result,"RGB_R")==0){
      RGB_RED=extractNumbers(req);
      Serial.println("result==RGB_R");
    }
    rgb_display_16.setBrightness(100);
    rgb_all(10,RGB_RED,RGB_GREEN,RGB_BLUE);
    rgb_display_16.show();
    Serial.println(RGB_GREEN);
    Serial.println(RGB_BLUE);
    Serial.println(RGB_RED);
  }
 
  if(req == "/door_on") 
  {
    servo_18.write(135);
    client.println("turn on the door");
  }
  if(req == "/door_off") 
  {
    servo_18.write(45);
    client.println("turn off the door");
  }
  if(req == "/window_on") 
  {
    servo_17.write(135);
    client.println("turn on the window");
  }
  if(req == "/window_off") 
  {
    servo_17.write(45);
    client.println("turn off the window");
  }
  if(req == "/bee_on") 
  {
    digitalWrite(19,HIGH);
    client.println("turn on the bee");
  }
  if(req == "/bee_off") 
  {
    digitalWrite(19,LOW);
    client.println("turn off the bee");
  }
  if(req == "/raindrop_req") 
  {
    s = "HTTP/1.1 200 0K\r\nContent-Type: text \r\n\r\n ";
    s += "raindrop_" + String(analogRead(33));
    s += "\r\n\r\n";
    client.println(s);
  }

  if(req == "/brightness_req") 
  {
    
    s = "HTTP/1.1 200 0K\r\nContent-Type: text \r\n\r\n ";
    s += String("brightness_") + String(analogRead(32));
    s += "\r\n\r\n";
    client.println(s);
  }

  if(req == "/PIR_req") 
  {
    s = "HTTP/1.1 200 0K\r\nContent-Type: text \r\n\r\n ";
    s += "PIR_" + String(digitalRead(14));
    s += "\r\n\r\n";
    client.println(s);
  }
  
  if(req == "/temperature_req") 
  {
    s = "HTTP/1.1 200 0K\r\nContent-Type: text \r\n\r\n ";
    s += "temperature_" + String(dht25.readTemperature());
    s += "\r\n\r\n";
    client.println(s);
  }

  if(req == "/humidity_req") 
  {
    s = "HTTP/1.1 200 0K\r\nContent-Type: text \r\n\r\n ";
    s += "humidity_" + String(dht25.readHumidity());
    s += "\r\n\r\n"; 
    client.println(s);
  }
  client.stop();
}

int hasNumber(String str) {
    int i = 0;
    while (str[i] != '\0') {
        if (str[i] >= '0' && str[i] <= '9') {
            return 1; // contains numbers
        }
        i++;
    }
    return 0; // does not contain numbers
}
int extractNumbers(String str) {
    // iterate over each character in the string
    int i = 0, numbers = 0;
    while (str[i] != '\0') {
        // if the character is a number, it is converted to an integer and added to numbers
        if (str[i] >= '0' && str[i] <= '9') {
            numbers = (numbers * 10) + (str[i] - '0');
        }
        i++;
    }
    return numbers;
}

void extractCharacters(String str, char *result) {
    int startIndex = 0;
    int endIndex = 0;

    // find the start of the character
    while (str[startIndex] != '/' && str[startIndex] != '\0') {
        startIndex++;
    }

    // find end-of-character position
    endIndex = startIndex + 1;
    while (str[endIndex] != '/' && str[endIndex] != '\0') {
        endIndex++;
    }

    // copy the character part to the result string
    int i;
    for (i = startIndex + 1; i < endIndex; i++) {
        result[i - startIndex - 1] = str[i];
    }
    result[i - startIndex - 1] = '\0';
}


/*****wifi control program 006*****/
